<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="catalog-page">

        <FiltersTop :data="data">
            <button class="button-stroke-transparent" @click="showCreateDatasetModal = true">Add artifact</button>
            <div class="filters-top-totals"><b>{{ data?.rows?.length }} Artifact(s)</b> related to this artifact</div>
        </FiltersTop>

        <div style="height: 40px;"></div>

        <div>
            <div class="datatable artifact-table">
                <div v-if="loading" class="loading-indicator">
                    <div class="spinner"></div>
                    <span>Loading data, please wait...</span>
                </div>
                <div class="datatable-body">
                    <div class="datatable-body-row accordion-style" v-for="(artifact, index) in data?.rows"
                        :key="artifact?.id">
                        <div class="datatable-body-row-column-name datatable-body-row-column"
                            @click="goColumns(artifact?.id, artifact?.type_dataset)">
                            <span class="catalog-item-name">{{ artifact?.name }}<span
                                    class="type-artifact">Artifact</span></span>
                        </div>
                        <div class="datatable-body-row-column-distinctEntries datatable-body-row-column"
                            @click="goColumns(artifact?.id, artifact?.type_dataset)">
                            <span></span>
                        </div>
                        <div class="datatable-body-row-column-missingValues datatable-body-row-column"
                            @click="goColumns(artifact?.id, artifact?.type_dataset)">
                            <span></span>
                        </div>
                        <div class="datatable-body-row-column-percentageMissingValues datatable-body-row-column"
                            @click="goColumns(artifact?.id, artifact?.type_dataset)">
                            <span></span>
                        </div>
                        <div class="datatable-body-row-column-uniquenessEntries datatable-body-row-column"
                            @click="goColumns(artifact?.id, artifact?.type_dataset)">
                            <span></span>
                        </div>
                        <div class="datatable-body-row-column-edited_at datatable-body-row-column"
                            @click="goColumns(artifact?.id, artifact?.type_dataset)">
                            <span></span>
                        </div>
                        <div class="datatable-body-row-column-actions datatable-body-row-column"
                            @click="goColumns(artifact?.id, artifact?.type_dataset)">
                            <span></span>
                        </div>
                        <div class="datatable-actions">
                            <button class="preview" @click="togglePreview(index)"><i
                                    class="icon-arrow-down"></i></button>
                        </div>
                        <div class="datatable-body-row-preview" v-if="isPreviewVisible(index) && artifact?.type_dataset === 'StructuredDataset'">
                            <div class="artifact-details-table">
                                <div class="line header">
                                    <div class="first-column">
                                    </div>
                                    <div class="column">
                                        <div>
                                            Num rows
                                        </div>
                                        <div>
                                            Duplicate entries
                                        </div>
                                        <div>
                                            Duplicate entries (%)
                                        </div>
                                        <div>
                                            Completeness
                                        </div>
                                        <div>
                                            Completeness (%)
                                        </div>
                                    </div>
                                </div>
                                <div class="line" v-for="(line, lineIndex) in artifactDetails[artifact.id]" :key="lineIndex" @click="goDetails(line?.id, artifact?.type_dataset)">
                                    <div class="first-column">
                                        {{ line.name }}
                                    </div>
                                    <div class="column" v-for="(column, columnIndex) in artifactColumns[line.id]"
                                        :key="columnIndex">
                                        <div v-for="(quality, qualityIndex) in filteredQualityMetrics(column.qualityMeasurements)"
                                            :key="qualityIndex">
                                            {{ quality.value }}
                                        </div>
                                    </div>
                                </div>


                                <div class="button-wrapper" @click="goColumns(artifact?.id, artifact?.type_dataset)">
                                    <button class="button-secondary purple">View more</button>
                                </div>
                            </div>
                        </div>
                        <div class="datatable-body-row-preview" v-if="isPreviewVisible(index) && artifact?.type_dataset === 'DatasetDatabase'">
                            <div class="row">
                                <div v-for="(artifactTable, artifactTableIndex) in artifactTables[artifact.id]" class="col-lg-6 col-xl-3" :key="artifactTableIndex">
                                    <div class="card-database" @click="goColunnsDatabase(artifact?.id, artifact?.type_dataset, artifactTable?.name)">
                                        <div class="card-database-header">
                                            <div class="card-database-title">{{ artifactTable?.name }} <i class="icon icon-arrow-right"></i></div>
                                        </div>
                                        <div class="card-database-footer">
                                            <div class="card-database-footer-item">
                                                <div class="card-database-footer-item-title">Lines</div>
                                                <div class="card-database-footer-item-value">{{ artifactDetails[artifactTable.id]?.columns?.length}}</div>
                                            </div>
                                            <div class="card-database-footer-item">
                                                <div class="card-database-footer-item-title">Columns</div>
                                                <div class="card-database-footer-item-value">10</div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="button-wrapper" @click="goColumns(artifact?.id, artifact?.type_dataset)">
                                <button class="button-secondary purple">View more</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <ClientOnly>
            <Teleport to="#modals-container">
                <ModalsCreateDataset v-if="showCreateDatasetModal" @toggle="close" :datasetId="datasetID" />
            </Teleport>
        </ClientOnly>

    </div>
</template>
<script setup lang="ts">
import { storeToRefs } from 'pinia';
import type DataTableI from '~/interfaces/datatable';
import { ref } from 'vue';
import { useArtifactStore } from '~/stores/dataStore';

const route = useRoute();
const datasetID = route.params.id as string;

const props = defineProps({
  artifactsData: {
    type: Object,
    required: true,
  },
});

const artifactStore = useArtifactStore();

useHead({
    title: 'Catalog - DATAMITE'
});

const loading = ref(false);

const showCreateDatasetModal = ref(false);

const close = () => {
    showCreateDatasetModal.value = false;
};

// make the function close available to emit in other components
defineExpose({ close });

interface ArtifactsArray {
    id: number;
    name: string;
    type: string;
    summary: string;
    description: string;
    distinctEntries: '',
    missingValues: '',
    percentageMissingValues: '',
    uniquenessEntries: '',
    updatedAt: string;
    createdAt: string;
}

interface ArtifactDetails {
    summary?: string;
    description?: string;
    updatedAt?: string;
    createdAt?: string;
}
// get artifacts row details
async function populateRows() {
    loading.value = true;
    
    let details: ArtifactDetails = {};
    try {
        // Create an array of promises for fetching artifact details
        const detailedRowsPromises = props?.artifactsData?.map(async (artifact: ArtifactsArray) => {
            try {
                if(artifact?.type === "StructuredDataset"){
                    details = await useFetchAuth(`/structuredFiles/${artifact.id}`) as ArtifactsArray;
                }else{
                    details = await useFetchAuth(`/databases/${artifact.id}`) as ArtifactsArray;
                }
                return {
                    id: artifact?.id,
                    name: artifact?.name,
                    type: 'Artifact',
                    type_dataset: artifact?.type,
                    summary: details?.summary || '',
                    description: details?.description || '',
                    distinctEntries: '',
                    missingValues: '',
                    percentageMissingValues: '',
                    uniquenessEntries: '',
                    edited_at: formatDate(details?.updatedAt) || '',
                    created_at: formatDate(details?.createdAt) || '',
                    actions: ''
                };
            } catch (error) {
                console.error(`Failed to fetch details for dataset ${artifact.id}:`, error);
                return {
                    id: artifact?.id,
                    name: artifact?.name,
                    type: 'Artifact',
                    type_dataset: artifact?.type,
                    summary: '',
                    description: '',
                    distinctEntries: '',
                    missingValues: '',
                    percentageMissingValues: '',
                    uniquenessEntries: '',
                    edited_at: '',
                    created_at: '',
                    actions: ''
                };
            }
        });

        // Wait for all API calls to resolve using Promise.all
        const detailedRows = await Promise.all(detailedRowsPromises);

        data.value = {
            ...data.value,
            rows: [...detailedRows],
        };
    } catch (error) {
        console.error('Failed to populate rows:', error);
    } finally {
        loading.value = false;
    }
}

const artifactDetails = ref<any[]>([]);
const artifactColumns = ref<any[]>([]);
const artifactTables = ref<any[]>([]);

// Function to fetch the artifact details for each artifact ID
const fetchArtifactDetails = async (artifactId: number, artifactType: string) => {
    try {

        if(artifactType === "StructuredDataset"){
            const [structuredFilesResponse, columnsResponse] = await Promise.all([
            useFetchAuth(`/structuredFiles/${artifactId}`) as Promise<{ columns: any[] }>,
            useFetchAuth(`/structuredFiles/${artifactId}/columns`) as Promise<any[]>
            ]);

            const columns = structuredFilesResponse?.columns?.slice(0, 3) || [];
            artifactDetails.value[artifactId] = columns;

            columns.forEach((column) => {
                // Filter columns where ID matches the column.id from the structuredFilesResponse
                artifactColumns.value[column.id] = columnsResponse?.filter(
                    (col: any) => col.id === column.id
                );
            });
        }else{
            const tablesResponse = await useFetchAuth(`/databases/${artifactId}/tables`) as Promise<any[]>;

            // Store the tables in artifactTables
            artifactTables.value[artifactId] = tablesResponse;

            // Fetch columns for each table
            const columnsPromises = (await tablesResponse).map((table: any) =>
                useFetchAuth(`/tables/${table.id}`).then((columns) => ({
                    tableId: table.id,
                    columns,
                }))
            );

            // Wait for all column fetches to complete
            const columnsResponses = await Promise.all(columnsPromises);

            // Store the columns in artifactDetails
            columnsResponses.forEach(({ tableId, columns }) => {
                artifactDetails.value[tableId] = columns;
            });
        }
        
    } catch (error) {
        console.error(`Failed to fetch details for artifact ID ${artifactId}`, error);
    }
};

onMounted(() => {
    populateRows();
    Promise.all(
        props?.artifactsData?.map((artifact: { id: number, type: string }) => fetchArtifactDetails(artifact.id, artifact.type))
    );
});

watch(() => props.artifactsData, (newData) => {
    populateRows();
    Promise.all(
        props?.artifactsData?.map((artifact: { id: number, type: string }) => fetchArtifactDetails(artifact.id, artifact.type))
    );
});

const data = ref<DataTableI>({
    options: {
        tableName: 'artifact-table',
        detailsPath: '/catalog/artifact/',
        allowCheckRow: false,
        favourites: false,
        previewComponent: 'ArtifactDetails',
    },
    columns: [
        {
            id: 1,
            name: 'name',
            label: 'Name',
            filterType: 'text',
            width: '250px',
            combineColumn: 'type',
            renderComponent: 'TableColumnsName'
        },
        {
            id: 2,
            name: 'distinctEntries',
            label: 'Distinct Entries',
            filterType: 'select',
            width: '150px'
        },
        {
            id: 3,
            name: 'missingValues',
            label: 'Missing values',
            filterType: 'select',
            width: '150px'
        },
        {
            id: 4,
            name: 'percentageMissingValues',
            label: 'Percentage missing values',
            width: '150px'
        },
        {
            id: 5,
            name: 'uniquenessEntries',
            label: 'Uniqueness Entries',
            filterType: 'select',
            width: '140px'
        },
        {
            id: 6,
            name: 'edited_at',
            label: 'Edited at',
            width: '70px'
        },
        {
            id: 7,
            name: 'actions',
            label: 'Actions',
            width: '80px',
            hideLabel: true
        }
    ],
    rows: []
});

const previewVisible = ref<number | null>(null);

const togglePreview = (index: number) => {
    previewVisible.value = previewVisible.value === index ? null : index;
};

const isPreviewVisible = (index: number) => {
    return previewVisible.value === index;
};

const goDetails = (id: number, type: string) => {
    navigateTo('/catalog/artifact/column/' + id);
}

const goColumns = (id: number, type: string) => {
    artifactStore.setArtifactType(type);
    navigateTo('/catalog/artifact/' + id);
}

const goColunnsDatabase = (id: number, type: string, section: string) => {
    artifactStore.setArtifactType(type);
    navigateTo(`/catalog/artifact/${id}#${section}`);
}

// filter quality measurements
const filteredQualityMetrics = (qualityMeasurements: any) => {
    const allowedMetrics = [
        'general.completeness',
        'general.completeness_percent',
        'general.duplicated_entries',
        'general.duplicated_entries_percent',
        'general.num_rows'
    ];
    return qualityMeasurements.filter((q: { metric: string }) => allowedMetrics.includes(q.metric));
}

</script>